//
// clamp generated lambda templates
// parser $Id: $
// code generator $Id: $
//

namespace {
template <typename T1, typename T2, typename T3>
struct lambda_template_1_1_const
{
  T1 (lambda_template_1_1_const::*mFn) (T3)const;
  T2 mContext1;

  typedef T1 result_type;
  typedef T2 context_type_1;
  typedef T3 argument_type_1;
  typedef T3 argument_type;

  // Constructor
  lambda_template_1_1_const (T1 (lambda_template_1_1_const::*fn) (T3)const, T2 c1)
   : mFn(fn), mContext1 (c1)
  { }

  // Forwarding function
  T1 operator() (T3 p1)const
  {
    return (this->*mFn)(p1);
  }

  T1 fn1 (T3)const;

  T1 fn8 (T3)const;
lambda_template_1_1_const() {}
lambda_template_1_1_const& operator= (lambda_template_1_1_const const &b) {
mFn = b.mFn;
mContext1 = b.mContext1;
return *this;
}
};
template <typename T1, typename T2, typename T3, typename T4, typename T5>
struct lambda_template_2_2_const
{
  T1 (lambda_template_2_2_const::*mFn) (T4, T5)const;
  T2 mContext1;
  T3 mContext2;

  typedef T1 result_type;
  typedef T2 context_type_1;
  typedef T3 context_type_2;
  typedef T4 argument_type_1;
  typedef T5 argument_type_2;
  typedef T4 first_argument_type;
  typedef T5 second_argument_type;

  // Constructor
  lambda_template_2_2_const (T1 (lambda_template_2_2_const::*fn) (T4, T5)const, T2 c1, T3 c2)
   : mFn(fn), mContext1 (c1), mContext2 (c2)
  { }

  // Forwarding function
  T1 operator() (T4 p1, T5 p2)const
  {
    return (this->*mFn)(p1, p2);
  }

  T1 fn2 (T4, T5)const;

  T1 fn3 (T4, T5)const;

  T1 fn5 (T4, T5)const;

  T1 fn6 (T4, T5)const;

  T1 fn7 (T4, T5)const;
lambda_template_2_2_const() {}
lambda_template_2_2_const& operator= (lambda_template_2_2_const const &b) {
mFn = b.mFn;
mContext1 = b.mContext1;
mContext2 = b.mContext2;
return *this;
}
};
template <typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8>
struct lambda_template_5_2_const
{
  T1 (lambda_template_5_2_const::*mFn) (T7, T8)const;
  T2 mContext1;
  T3 mContext2;
  T4 mContext3;
  T5 mContext4;
  T6 mContext5;

  typedef T1 result_type;
  typedef T2 context_type_1;
  typedef T3 context_type_2;
  typedef T4 context_type_3;
  typedef T5 context_type_4;
  typedef T6 context_type_5;
  typedef T7 argument_type_1;
  typedef T8 argument_type_2;
  typedef T7 first_argument_type;
  typedef T8 second_argument_type;

  // Constructor
  lambda_template_5_2_const (T1 (lambda_template_5_2_const::*fn) (T7, T8)const, T2 c1, T3 c2, T4 c3, T5 c4, T6 c5)
   : mFn(fn), mContext1 (c1), mContext2 (c2), mContext3 (c3), mContext4 (c4), mContext5 (c5)
  { }

  // Forwarding function
  T1 operator() (T7 p1, T8 p2)const
  {
    return (this->*mFn)(p1, p2);
  }

  T1 fn4 (T7, T8)const;
lambda_template_5_2_const() {}
lambda_template_5_2_const& operator= (lambda_template_5_2_const const &b) {
mFn = b.mFn;
mContext1 = b.mContext1;
mContext2 = b.mContext2;
mContext3 = b.mContext3;
mContext4 = b.mContext4;
mContext5 = b.mContext5;
return *this;
}
};


template <typename T1, typename T3>
struct lambda_generator_1
{
  template <typename T2>
  static lambda_template_1_1_const <T1, T2 &, T3>
  generate(T2 &p1)
  {
    return lambda_template_1_1_const <T1, T2 &, T3> (&lambda_template_1_1_const <T1, T2 &, T3>::fn1, p1);
  }
};

template <typename T1, typename T4, typename T5>
struct lambda_generator_2
{
  template <typename T2, typename T3>
  static lambda_template_2_2_const <T1, T2, T3, T4, T5>
  generate(T2 p1, T3 p2)
  {
    return lambda_template_2_2_const <T1, T2, T3, T4, T5> (&lambda_template_2_2_const <T1, T2, T3, T4, T5>::fn2, p1, p2);
  }
};

template <typename T1, typename T4, typename T5>
struct lambda_generator_3
{
  template <typename T2, typename T3>
  static lambda_template_2_2_const <T1, T2, T3, T4, T5>
  generate(T2 p1, T3 p2)
  {
    return lambda_template_2_2_const <T1, T2, T3, T4, T5> (&lambda_template_2_2_const <T1, T2, T3, T4, T5>::fn3, p1, p2);
  }
};

template <typename T1, typename T7, typename T8>
struct lambda_generator_4
{
  template <typename T2, typename T3, typename T4, typename T5, typename T6>
  static lambda_template_5_2_const <T1, T2, T3 &, T4 &, T5 &, T6 &, T7, T8>
  generate(T2 p1, T3 &p2, T4 &p3, T5 &p4, T6 &p5)
  {
    return lambda_template_5_2_const <T1, T2, T3 &, T4 &, T5 &, T6 &, T7, T8> (&lambda_template_5_2_const <T1, T2, T3 &, T4 &, T5 &, T6 &, T7, T8>::fn4, p1, p2, p3, p4, p5);
  }
};

template <typename T1, typename T4, typename T5>
struct lambda_generator_5
{
  template <typename T2, typename T3>
  static lambda_template_2_2_const <T1, T2, T3, T4, T5>
  generate(T2 p1, T3 p2)
  {
    return lambda_template_2_2_const <T1, T2, T3, T4, T5> (&lambda_template_2_2_const <T1, T2, T3, T4, T5>::fn5, p1, p2);
  }
};

template <typename T1, typename T4, typename T5>
struct lambda_generator_6
{
  template <typename T2, typename T3>
  static lambda_template_2_2_const <T1, T2, T3, T4, T5>
  generate(T2 p1, T3 p2)
  {
    return lambda_template_2_2_const <T1, T2, T3, T4, T5> (&lambda_template_2_2_const <T1, T2, T3, T4, T5>::fn6, p1, p2);
  }
};

template <typename T1, typename T4, typename T5>
struct lambda_generator_7
{
  template <typename T2, typename T3>
  static lambda_template_2_2_const <T1, T2, T3, T4, T5>
  generate(T2 p1, T3 p2)
  {
    return lambda_template_2_2_const <T1, T2, T3, T4, T5> (&lambda_template_2_2_const <T1, T2, T3, T4, T5>::fn7, p1, p2);
  }
};

template <typename T1, typename T3>
struct lambda_generator_8
{
  template <typename T2>
  static lambda_template_1_1_const <T1, T2 &, T3>
  generate(T2 &p1)
  {
    return lambda_template_1_1_const <T1, T2 &, T3> (&lambda_template_1_1_const <T1, T2 &, T3>::fn8, p1);
  }
};

} /* anonymous namespace */

#include <stdint.h>
#include <boost/regex.hpp>
#include <string>
#include <vector>
#include <cstdio>
#include <sstream>
#include <map>

#include "hash.hh"
#include "rangeset.hh"

static bool EXTERNAL_OPERATORS = true;

typedef signed long long IntType;

enum rule_type_t
{
    static_rule,
    dynamic_rule,
    plain_numbers
};

struct IfRangeComparison
{
    unsigned lower; // inclusive
    unsigned upper; // exclusive
    bool is_switchcase;
    bool is_unconditional;
    std::string return_rule;
    unsigned complexity;
};
typedef std::vector<IfRangeComparison> IfRangeSet;

template<typename T>
static const IfRangeSet CreateCaseRule
   (const std::vector<bool>& map,
    std::vector<bool>& dontcareset,
    bool wanted_state,
    rule_type_t rule_type,
    T command,
    unsigned begin=0, unsigned end=~0U)
{
    if(end == ~0U) end = map.size();
    
    unsigned range_first=0, range_last=0;
    bool range_active=false;
    
    const unsigned min_split_distance =
        rule_type == plain_numbers
            ? 12
            : 64-7;
    
    IfRangeSet result;
    
    for(unsigned a=begin; a<end; ++a)
        if(map[a] == wanted_state
        // && !dontcareset[a]
        )
        {
            if(!range_active)
                { newrange: range_first=range_last=a; range_active = true; continue; }
            unsigned distance = a - range_last;
            if(distance >= min_split_distance)
            {
                IfRangeSet tmp =
                    CreateCaseRule(map, dontcareset, wanted_state,
                                   rule_type, command,
                                   range_first, range_last+1);
                result.insert(result.end(), tmp.begin(), tmp.end());
                goto newrange;
            }
            range_last = a;
        }
     
    if(!range_active) IgnoreRule: return result;
    
    begin = range_first;
    end   = range_last + 1;
    
    IfRangeComparison comp;
    comp.lower = begin;
    comp.upper = end;
    comp.is_switchcase = false;
    comp.is_unconditional = false;
    comp.complexity = 0;
    std::stringstream res;
    
    if(rule_type == static_rule)
    {
        bool majorly_matching = false;
        unsigned num_total = end-begin;
        unsigned num_ok    = 0;
        unsigned num_dontcare = 0;
        bool all_dontcare = true;
        for(unsigned a=begin; a<end; ++a)
        {
            if(map[a] == wanted_state)
            {
                ++num_ok;
                if(!dontcareset[a]) all_dontcare = false;
            }
            if(dontcareset[a]) ++num_dontcare;
        }
        if(all_dontcare) goto IgnoreRule;
        
        res << "/* " << num_ok << " matching out of " << num_total;
        if(num_dontcare) res << ", " << num_dontcare << " dontcare";
        res << " */\n";
        
        if(num_ok >= num_total / 2)
        {
            majorly_matching = true;
            wanted_state = !wanted_state;
            num_ok = num_total - num_ok;
        }
        
        rangeset<unsigned> ranges;
        for(unsigned a=begin; a<end; ++a)
        {
            if(dontcareset[a])
            {
                if(wanted_state) goto r1;
                else continue;
            }
            if(map[a] == wanted_state)
            {
              r1:
                ranges.insert(a);
            }
        }
        
        if(!ranges.empty())
        {
            if(ranges.size() <= 3)
            {
                rangeset<unsigned>::const_iterator i = ranges.begin();
                
                if(i->lower > begin || i->upper < end)
                {
                    res << "if(";
                    if(majorly_matching) res << '!';
                    res << "(";
                    
                    bool first = true;
                    for(; i != ranges.end(); ++i)
                    {
                        comp.complexity += 4;
                        
                        if(first) first=false; else res << " || ";
                        res << "(index >= " << i->lower
                         << " && index < " << i->upper
                         << ")";
                    }
                    
                    res << "))\n\t";
                }
            }
            else
            {
                unsigned dim = (end-begin + 7) / 8;
                unsigned granu = 8;
                
                // because of aligning, we maybe better round it up anyway
                if(dim&3) dim=(dim+3)&~3;
                
                std::string type = "uint_least8_t", suff="UINT8_C";
                if(!(dim & 1)) { granu=16; type="uint_least16_t"; suff="UINT16_C"; dim >>= 1;
                if(!(dim & 1)) { granu=32; type="uint_least32_t"; suff="UINT32_C"; dim >>= 1;
#if defined(__WORDSIZE) && (__WORDSIZE == 64)
                if(!(dim & 1)) { granu=64; type="uint_least64_t"; suff="UINT64_C"; dim >>= 1;}
#endif
                }}

                if(dim == 1)
                {
                    comp.complexity += 1;

                    uint_least64_t bits = 0;
                    unsigned bitpos=0;
                    for(unsigned a=begin; a<end; ++a)
                    {
                        bits |= (uint_least64_t)(map[a] == wanted_state) << bitpos;
                        ++bitpos;
                        if(map[a] == wanted_state) dontcareset[a] = true;
                    }
                    
                    res << "unsigned bitpos  = (index-" << begin << ")%" << granu << ";\n";
                    res << "if(";
                    if(majorly_matching) res << '!';
                    res << "(" << suff << '(' << bits << ") & (" << suff << "(1) << bitpos)))";
                }
                else
                {
                    comp.complexity += 2;

                    res << "static const " << type << " bitset[" << dim << "] = {\n";
                    uint_least64_t bits = 0;
                    unsigned bitpos=0;
                    for(unsigned a=begin; a<end; ++a)
                    {
                        bits |= (uint_least64_t)(map[a] == wanted_state) << bitpos;
                        if(++bitpos == granu) { res << suff << '(' << bits << "),"; bitpos=bits=0; } 
                    }
                    if(bitpos) { res << suff << '(' << bits << ')'; }
                    res << "};\n";
                    res << "unsigned bitslot = (index-" << begin << ")/" << granu << ";\n";
                    res << "unsigned bitpos  = (index-" << begin << ")%" << granu << ";\n";
                    res << "if(";
                    if(majorly_matching) res << '!';
                    res << "(bitset[bitslot] & (" << suff << "(1) << bitpos)))";
                }
            }
        }
        else
        {
            comp.is_unconditional = true;
        }

        for(unsigned a=begin; a<end; ++a)
            if(map[a] == wanted_state ^ majorly_matching)
                dontcareset[a] = true;
        res << "return " << command(0) << ";\n";
    }
    else
    {
        unsigned num_total = end-begin;
        
        if(num_total == 1)
        {
            if(dontcareset[begin]) goto IgnoreRule;
            res << "return " << command(begin) << ";\n";
            comp.is_unconditional = true;
            dontcareset[begin] = true;
        }
        else
        {
            rangeset<unsigned> ranges;
            for(unsigned a=begin; a<end; ++a)
                if(map[a] == wanted_state
                ) ranges.insert(a);

            if(rule_type == plain_numbers)
            {
                IntType minvalue = 0, maxvalue = 0;
                bool first = true;
                for(unsigned a=begin; a<end; ++a)
                {
                    std::stringstream tmp;
                    tmp << command(a);
                    IntType value; tmp >> value;
                    if(first || value < minvalue) minvalue=value;
                    if(first || value > maxvalue) maxvalue=value;
                    first = false;
                }
                IntType range = maxvalue - minvalue + 1;
                std::string type;
                IntType limit;
                
                if(range <= 256) { type="uint_least8_t"; limit=256; }
                else if(range <= 65536) { type="uint_least16_t"; limit=65536; }
                else { type="unsigned long"; limit=0; }
                
                if(limit > 0 && minvalue+range <= limit)
                {
                    minvalue=0;
                }
                
                comp.is_unconditional = true;
                
                ++comp.complexity;

                res << "static const " << type << " datatable[" << num_total << "] = {";
                for(unsigned a=begin; a<end; ++a)
                {
                    std::stringstream tmp;
                    tmp << command(a);
                    IntType value; tmp >> value;

                    res << (value - minvalue) << ',';
                    
                    dontcareset[a] = true;
                }
                res << "};\n";
                res << "return datatable[index - " << begin << "] + " << minvalue << ";\n";
            }
            else
            {
                comp.is_switchcase = true;
                
                for(unsigned a=begin; a<end; ++a)
                    if(map[a] == wanted_state)
                    {
                        ++comp.complexity;
                        res << " case " << a << ": return " << command(a) << ";\n";
                        dontcareset[a] = true;
                    }
            }
        }
    }
    comp.return_rule = res.str();
    
    result.push_back(comp);
    return result;
}

struct Table
{
    std::vector<IntType> values;
    std::vector<bool>   handled;
    
    std::string tab_name;
    std::string elem_type;
    
    const IfRangeSet CreateFallback(std::vector<bool>& dontcareset) const
    {
        return CreateCaseRule(handled, dontcareset,
                              false, plain_numbers,
             lambda_generator_1<unsigned, unsigned>::generate(values)
                             );
    }
};
struct Method
{
    std::vector<bool> coverage;
    std::string formula;
    rule_type_t rule_type;
};

static void TranslateTable(Table& tab)
{
    const std::vector<IntType>& values = tab.values;
    const unsigned size                = tab.values.size();
    tab.handled.resize(size, false);
    std::vector<Method> methods;
    
    /* PASS 2: Offset expressions */
    
    //size_t DataAmount = 0;
    
    hash_set<std::string> done_sets;
    for(;;)
    {
        typedef lambda_template_2_2_const<bool, IntType, IntType, unsigned, IntType> Tester;
    
        std::string most_freq_val;
        Tester      most_freq_test;
        unsigned most_freq=0;
        
        {std::map<IntType, unsigned> offs_freqs;
        for(unsigned a=0; a<size; ++a)
        {
            if(tab.handled[a]) continue;

            IntType value = values[a]-a;
            //if(done_sets.find(tmp.str()) != done_sets.end()) continue;

            unsigned freq = ++offs_freqs[value];
            if(freq > most_freq)
            {
                std::stringstream tmp; tmp << "index + " << value;
                IntType dummy=0;
                
                most_freq_val  = tmp.str();
                most_freq_test =
                    lambda_generator_2<bool, unsigned, IntType>::generate(dummy, value);
                most_freq = freq;
            }
        }}

        {std::map<IntType, unsigned> val_freqs;
        for(unsigned a=0; a<size; ++a)
        {
            if(tab.handled[a]) continue;
            IntType value = values[a];
            //if(done_sets.find(tmp.str()) != done_sets.end()) continue;

            unsigned freq = ++val_freqs[value];
            if(freq > most_freq)
            {
                std::stringstream tmp; tmp << value;
                IntType dummy=0;
                most_freq_val  = tmp.str();
                most_freq_test =
                    lambda_generator_3<bool, unsigned, IntType>::generate(dummy, value);
                most_freq = freq;
            }
        }}

        ///*hash_set<std::string>&,
        lambda_template_5_2_const<void, unsigned, Table &, unsigned &, std::string &, lambda_template_2_2_const<bool, IntType, IntType, unsigned, IntType>  &, const std::string &, lambda_template_2_2_const<bool, IntType, IntType, unsigned, IntType> > DoTesting =
        lambda_generator_4<void, const std::string &, lambda_template_2_2_const<bool, IntType, IntType, unsigned, IntType> >::generate(size, tab, most_freq, most_freq_val, most_freq_test);
        
        for(IntType diffs=-100; diffs<=100; ++diffs)
        for(IntType  muls=2; muls<=4; ++muls)
        {
            std::stringstream s;
            s << "index * " << muls << " + " << diffs;
            DoTesting(s.str(),
                      lambda_generator_5<bool, unsigned, IntType>::generate(muls, diffs)
                     );
        }
#if 0
        for(IntType diffs=0; diffs<=60; ++diffs)
        for(IntType ands=1; ands<=256; ands<4 ? ++ands : ands<<=1)
        {
            std::stringstream s;
            s << "(index + " << diffs << ") & " << ands;
            DoTesting(s.str(),
                      lambda_generator_6<bool, unsigned, IntType>::generate(diffs, ands)
                     );
        }
        for(IntType diffs=0; diffs<=60; ++diffs)
        for(IntType ors=1; ors<=256; ors<4 ? ++ors : ors<<=1)
        {
            std::stringstream s;
            s << "(index + " << diffs << ") | " << ors;
            DoTesting(s.str(),
                      lambda_generator_7<bool, unsigned, IntType>::generate(diffs, ors)
                     );
        }
#endif
        
        if(most_freq < 30) break;
        
        done_sets.insert(most_freq_val);
        
        // 10: 463800
        // 20: 463112
        // 30: 463112
        // 40: 463112
        // 50: 463352
        
        Method met;
        met.coverage.resize(size);
        for(unsigned a=0; a<size; ++a)
            if(most_freq_test(a, values[a]))
            {
                met.coverage[a] = true;
                tab.handled[a] = true;
            }
        
        met.formula   = most_freq_val;
        met.rule_type = static_rule;
        methods.push_back(met);
    }
    
    IfRangeSet ranges;
    std::vector<bool> covered(size, false);
    if(true)
    {
        IfRangeSet tmp = tab.CreateFallback(covered);
        ranges.insert(ranges.end(), tmp.begin(), tmp.end());
    }
    
    /* Create them in order of complexity. Lower-compexity ones first. */
    std::vector<bool> done(methods.size(), false);
    for(unsigned a=0; a<methods.size(); ++a)
    {
        IfRangeSet best;
        unsigned best_complexity=0, best_idx=0;
        std::vector<bool> best_covered;
        bool first=true;
        for(unsigned b=0; b<methods.size(); ++b)
            if(!done[b])
            {
                std::vector<bool> covered_backup = covered;
                IfRangeSet tmp = 
                    CreateCaseRule(methods[b].coverage, covered_backup,
                                   true, methods[a].rule_type,
                                   lambda_generator_8<const std::string &, unsigned>::generate(methods[b])
                                  );
                unsigned com = 0;
                for(unsigned c=0; c<tmp.size(); ++c)
                    com += tmp[c].complexity;
                if(first || com < best_complexity)
                {
                    best = tmp;
                    best_complexity = com;
                    best_idx = b;
                    best_covered = covered_backup;
                    first=false;
                }
            }
        
        done[best_idx] = true;
        ranges.insert(ranges.end(), best.begin(), best.end());
        covered = best_covered;
    }
    
    std::string code;
    /*
    std::sort(ranges.begin(), ranges.end(),
              const lambda bool(const IfRangeComparison&a, const IfRangeComparison& b)
              { return a.lower < b.lower; } );
    */
    
    for(unsigned a=0; a<ranges.size(); ++a)
    {
        const IfRangeComparison& r = ranges[a];
        std::stringstream tmp;
        //tmp << "/* rule " << a << " */";
        
        if(r.is_switchcase)
        {
            tmp << "switch(index) {\n";
            tmp << r.return_rule;
            tmp << "}\n";
        }
        else if(r.upper == r.lower+1)
        {
            tmp << "if(index == " << r.lower << ") {\n" << r.return_rule << "}\n";
        }
        else if(r.lower == 0 && r.upper == size)
        {
            //tmp << "/* all covering rule */";
            tmp << r.return_rule;
            if(r.is_unconditional) { code += tmp.str(); goto all_done; }
        }
        else if(r.lower == 0)
        {
            tmp << "if(index < " << r.upper << ") {\n" << r.return_rule << "}\n";
        }
        else if(r.upper == size)
        {
            tmp << "if(index >= " << r.lower << ") {\n" << r.return_rule << "}\n";
        }
        else
        {
            tmp << "if(";
            if(r.lower > 0) tmp << "index >= " << r.lower << " && ";
            tmp << "index < " << r.upper << ") {\n" << r.return_rule << "}\n";
        }
        code += tmp.str();
    }
    code += "return 0;"; all_done:

    std::printf("static struct %s_generator {\n", tab.tab_name.c_str());

    if(EXTERNAL_OPERATORS)
    {
        std::printf("  %s operator[] (unsigned index) const;\n", tab.elem_type.c_str());
    }
    else
    {
        std::printf("  %s operator[] (unsigned index) const {\n", tab.elem_type.c_str());
        std::printf("  %s\n", code.c_str());
        std::printf("\n}\n");
    }
    std::printf("} %s;\n", tab.tab_name.c_str());

    if(EXTERNAL_OPERATORS)
    {
        std::printf("%s %s_generator::operator[] (unsigned index) const {\n",
            tab.elem_type.c_str(),
            tab.tab_name.c_str());
        std::printf("  %s\n", code.c_str());
        std::printf("\n}\n");
    }
    //std::printf("/* Amount of data: %u bytes */\n", DataAmount);
}

static void TranslateTable(const std::string& type,
                           unsigned dim,
                           const std::string& name,
                           const std::string& contents)
{
    Table tab;
    tab.tab_name = name;
    tab.elem_type = type;
    tab.values.reserve(dim);
    for(const char*s = contents.c_str(); *s; )
    {
        while(*s && *s == ' ' || *s == '\t' || *s == '\r' || *s == '\n') ++s;
        
        int base = 10;
        if(*s == '0' && s[1] == 'x') { base=16; s+=2; }
        else if(*s == '0') { base=8; ++s; }
        tab.values.push_back(strtol(s, const_cast<char**>(&s), base));

        while(*s && *s == ' ' || *s == '\t' || *s == '\r' || *s == '\n') ++s;
        if(*s == ',') { ++s; continue; }
    }
    tab.values.resize(dim, 0);
    TranslateTable(tab);
}
                           
static void Find(const std::string& pattern)
{
    unsigned type_idx = 0;
    unsigned name_idx = 0;
    unsigned value_idx = 0;
    unsigned dim_idx = 0;
    
    unsigned idx_count=0;
    std::string regex_str;
    for(unsigned a=0; a<pattern.size(); ++a)
    {
        char ch = pattern[a];
        if(ch == '$')
            switch(pattern[++a])
            {
                case 'T':
                    type_idx = idx_count++;
                    regex_str += "([A-Za-z_0-9 ]*)";
                    break;
                case 'N':
                    name_idx = idx_count++;
                    regex_str += "([A-Za-z_][A-Za-z_0-9]*)";
                    break;
                case 'D':
                    dim_idx = idx_count++;
                    regex_str += "([0-9]+)";
                    break;
                case 'A':
                    value_idx = idx_count++;
                    regex_str += "([0-9,\r\n ]+)";
                    break;
            }
        else if(ch == '?')
            regex_str += "[\t\r\n ]*";
        else if(ch == ' ')
            regex_str += "[\t\r\n ]+";
        else
        {
            if(ch == '\\' || ch == '{' || ch == '}'
            || ch == '*' || ch == '^' || ch == '$'
            || ch == '[' || ch == ']'
            || ch == '(' || ch == ')' || ch == '+') regex_str += '\\';
            regex_str += ch;
        }
    }
    
    //printf("regex = '%s'\n", regex_str.c_str());

    boost::regex regex(regex_str);
    
    std::string input;
    while(!std::feof(stdin) && !std::ferror(stdin))
    {
        char Buf[8192];
        int n = std::fread(Buf,1,sizeof(Buf),stdin);
        if(n > 0) input.append(Buf, Buf+n);
    }
    boost::smatch res;
    
    std::string::const_iterator begin = input.begin();
    std::string::const_iterator  end  = input.end();
    
    for(;;)
    {
        if(!boost::regex_search(begin,end, res, regex)) break;
        
        std::fwrite(&*begin, 1, res[0].first-begin,  stdout);
        
        begin = res[0].second;
        
        std::string type = res[type_idx+1].str();
        std::string name = res[name_idx+1].str();
        std::string value= res[value_idx+1].str();
        std::string dim  = res[dim_idx+1].str();
        
        TranslateTable(type, std::atoi(dim.c_str()), name, value);
    }

    std::fwrite(&*begin, 1, end-begin,  stdout);
}

int main()
{
    std::puts("#define __STDC_CONSTANT_MACROS");
    std::puts("#include <stdint.h>");
    Find("static $T $N?[?$D?]?=?{?$A?}?;");
}
template <typename T1, typename T2, typename T3>
T1 lambda_template_1_1_const<T1, T2, T3>::fn1 (T3 a)const
{ return mContext1[a]; 


}
template <typename T1, typename T2, typename T3>
T1 lambda_template_1_1_const<T1, T2, T3>::fn8 (T3)const
{ return mContext1.formula; 


}
template <typename T1, typename T2, typename T3, typename T4, typename T5>
T1 lambda_template_2_2_const<T1, T2, T3, T4, T5>::fn2 (T4 a, T5 val)const
{
                        if(mContext1){} // dummy
                        return val == a + mContext2;
                    


}
template <typename T1, typename T2, typename T3, typename T4, typename T5>
T1 lambda_template_2_2_const<T1, T2, T3, T4, T5>::fn3 (T4, T5 val)const
{
                        if(mContext1){} // dummy
                        return val == mContext2;
                    


}
template <typename T1, typename T2, typename T3, typename T4, typename T5>
T1 lambda_template_2_2_const<T1, T2, T3, T4, T5>::fn5 (T4 a, T5 val)const
{ return val == ((a * mContext1) + mContext2); 


}
template <typename T1, typename T2, typename T3, typename T4, typename T5>
T1 lambda_template_2_2_const<T1, T2, T3, T4, T5>::fn6 (T4 a, T5 val)const
{ return val == ((a + mContext1) & mContext2); 


}
template <typename T1, typename T2, typename T3, typename T4, typename T5>
T1 lambda_template_2_2_const<T1, T2, T3, T4, T5>::fn7 (T4 a, T5 val)const
{ return val == ((a + mContext1) | mContext2); 


}
template <typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8>
T1 lambda_template_5_2_const<T1, T2, T3, T4, T5, T6, T7, T8>::fn4 (T7 val, T8 test)const
{
            //bool needs_check = __ref(done_sets).find(val) != __ref(done_sets).end();
            
            unsigned freq = 0;
            for(unsigned a=0; a < mContext1; ++a)
            {
                if(mContext2.handled[a]) continue;
                if(test(a, mContext2.values[a])) ++freq;
            }
            if(freq > mContext3)
            {
                mContext3      = freq;
                mContext4  = val;
                mContext5 = test;
            }
        


}

