tokcase(MID_S,    "(V,N?,N)=S");
     /* system commands */
tokcase(STOP,      "");
tokcase(END,       "");
tokcase(SYSTEM,   "");
tokcase(SHELL,    "s");
tokcase(SLEEP,    "n");
tokcase(POKE,     "N,N");
tokcase(OUT,      "N,N");
tokcase(WAIT,     "N,N,n");
tokcase(DEFSEG,   "?=N");
tokcase(TIME_S,   "=S");
tokcase(DATE_S,   "=S");
tokcase(CLEAR,    "n?,n?,n");
tokcase(BEEP,     "");

tokcase(KILL,     "S");
tokcase(FILES,    "s");
tokcase(SEEK,     "F,N");
tokcase(CHDIR,    "S");
tokcase(MKDIR,    "S");
tokcase(RMDIR,    "S");
tokcase(ERROR,    "N");

     /* graphics commands */
tokcase(LOCATE,   "n?,n?,n?,n?,n");  // row,col, cursor_{vis,start,stop}
tokcase(SCREEN,   "n?,n?,n?,n");     // mode,colorswitch,apage,vpage
tokcase(COLOR,    "n?,n?,n");        // fg,bg,border
tokcase(PAINT,    "P?,x?,n?,s");     // coord, pattern/paint, bordercolor, background
tokcase(CIRCLE,   "P,N?,n?,n?,n?,n"); // coord, radius, color, start, end, aspect
tokcase(PSET,     "P?,n"); //coord,color
tokcase(PRESET,   "P?,n");
tokcase(CLS,      "n");   //clear_level (0/1/2)
tokcase(DRAW,     "S");
tokcase(GET,      "P-P,A"
                  "|"
                  "F?,n?,V");
tokcase(PUT,      "P,A?,zp"
                  "|"
                  "F?%n?,V");
tokcase(VIEWPRINT,    "N ZT N"
                      "|");
tokcase(VIEW,           "zs C-C?,n?,n"); // [SCREEN] coord-coord,color,border
tokcase(PALETTE_USING,  "A");
tokcase(PALETTE,        "n?,n");
tokcase(LINE,           "p-P?,n?,zl?,n");  // coord-coord, color, B/BF, style (16-bit intmask)
tokcase(WIDTH_LPRINT, "N");
tokcase(WIDTH_F,  "N");
tokcase(WIDTH,    "S,N"
                  "|"
                  "n?,n");


     /* event commands */
tokcase(PLAY,     "ZK"
                  "|"
                  "%S");
tokcase(TIMER,    "ZK");
tokcase(KEY,      "ZH"
                  "|"
                  "N,S");

tokcase(RANDOMIZE, "N"
                   "|"
                   ""); // User will be prompted for random seed
